/***********************************************************************************
*  Sxipper
*  Copyright (c) 2006-2008 Sxip Identity Corporation
*  http://www.sxip.com
*
*  Patents pending.
* 
***********************************************************************************/ 
/*
 * Sxipper - Application XPCOM Component
 * 
 * Developing notes: change to this file requires removing xpti.dat and compreg.dat
 * from the dev profile directory. 
 */


/***********************************************************
constants
***********************************************************/
const CI = Components.interfaces;

// UUID uniquely identifying our component
const CLASS_ID = Components.ID("{ba7359d0-75af-11db-9fe1-0800200c9a66}");

// description
const CLASS_NAME = "Sxipper - Application XPCOM Component";

// textual unique identifier
const CONTRACT_ID = "@sxip.com/sxipper/application;1";

var smJslib = {};

	    
function smInclude(url) {
	var scriptLoader =  Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
		getService(Components.interfaces.mozIJSSubScriptLoader);
	scriptLoader.loadSubScript(url);
}
	
/***********************************************************
 class definition

 insert application wide functions/variables below

***********************************************************/

//class constructor
function SxipperService() {
	this.wrappedJSObject = this;
	this.isApplicationInitialized = null;
	// user/map info cache
	this.mapInfoCache = {};
	this.noCacheDomainHashTable = {};
	
	/*
	// registration record
	this.registrationRecordFields = null;
	this.registrationRecordMap = null;
	this.registrationRecordDomain = null;
	*/
	
	// cache of (single form) maps used by browser context menu
	this.mapCache = {};
	this.mapCachePerFormHash = {};
	
	this.formUrlHashtable = {};

	this.model = null;
	this.userManager = null;
	this.setupShowOnce = false;
};

// class definition
SxipperService.prototype = {

  // define the function we want to expose in our interface
  hello: function() {
      return "XPCOM Hello World!";
  },
    init: function() {
    try {
	// TODO investigate how to load them in global memory
  	// bootstrap load jslib
	Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Components.interfaces.mozIJSSubScriptLoader)
	    .loadSubScript("chrome://sxipper/content/jslib/jslib.js", smJslib);
	// load everything else using jslib include
	smJslib.include(smJslib.JS_LIB_PATH+"debug/debug.js");
	smJslib.include(smJslib.JS_LIB_PATH+"io/file.js");
	smJslib.include(smJslib.JS_LIB_PATH+"io/fileUtils.js");
	smJslib.include(smJslib.JS_LIB_PATH+"io/dirUtils.js");
//	smJslib.include(smJslib.JS_LIB_PATH+"rdf/rdfBase.js");
//	smJslib.include(smJslib.JS_LIB_PATH+"rdf/rdfResource.js");
//	smJslib.include(smJslib.JS_LIB_PATH+"rdf/rdfContainer.js");
//	smJslib.include(smJslib.JS_LIB_PATH+"rdf/rdf.js");
	smJslib.include(smJslib.JS_LIB_PATH+"rdf/rdfFile.js");
	
	
	smInclude("chrome://sxipper/content/constants.js");
	smInclude("chrome://sxipper/content/utils.js");
	smInclude("chrome://sxipper/content/promptService.js");
	smPromptService = new smIPromptService();
	smInclude("chrome://sxipper/content/config.js");
	smInclude("chrome://sxipper/content/message.js");
	smInclude("chrome://sxipper/content/schema.js");
	smInclude("chrome://sxipper/content/group-schema.js");
	smInclude("chrome://sxipper/content/model.js");
	smInclude("chrome://sxipper/content/ledger.js");
	smInclude("chrome://sxipper/content/updateManager.js");
	smInclude("chrome://sxipper/content/formHandler.js");
	smInclude("chrome://sxipper/content/httpObserver.js");
	smInclude("chrome://sxipper/content/userManager.js");
	this.userManager = new smIUserManager();
	smUserManager = this.userManager;

	var isRewritingModelEnabled = false;
	var isUpdate = this.isUpdate();

	smUtils.debug("XPCOM initializing data store");
	try {
		smDataStore = Components.classes["@sxip.com/sxipper/datastore;1"]
								.getService().wrappedJSObject;
		//smUtils.debug("common.js: "+smDataStore.hello());
	} catch (e) {
		smUtils.debug("Couldn't load smDataStore XPCOM component", L_ERROR);
		//throw e;
	}

	
	smUtils.debug("XPCOM initializing model");
	//dump("\nXPCOM initializing model\n");
	this.model = new smModelClass(smConstants.filenameSxipperProfileData, isRewritingModelEnabled);
	smModel=this.model; // for formHanlder.js use

	// interestingl, the following statement causes certain FF installations
	// to have a better timing, so that pages are not loaded before pageloadlistner
	// is registered
	// TODO remove..
	var sxipperEnabled = smConfig.getBoolPref("sxipperEnabled");
	if (sxipperEnabled) {
		//this.userManager.prepareHttpAuth(); // TODO: run on demand
	}
    smInclude("chrome://sxipper/content/openid.js");
    // workaround for singleton oidPhishingProtection
    this.oidPhishingProtection = oidPhishingProtection;
	smInclude("chrome://sxipper/content/map.js");
	//smInclude("chrome://sxipper/content/updateManager.js");
	smInclude("chrome://sxipper/content/release.js");
	
	//used by smHttpObserver;
	sxipperService = this;

	smHttpObserver.start();
	
	/* currently not required here at
	smInclude(smJslib.JS_LIB_PATH+"sound/sound.js");
	*/
	/*
    // Watch out: a module below (usermanager) creates a "Bus error"
	smLog("loading openid srv api");
	smInclude("chrome://sxipper/content/openid-srvapi.js.js");
	smInclude("chrome://sxipper/content/message.js");
	smInclude("chrome://sxipper/content/view.js");
	smInclude("chrome://sxipper/content/priming.js");
	smInclude("chrome://sxipper/content/greyout.js");
	smInclude("chrome://sxipper/content/common.js");
  	*/
  	
  	} catch (e) {
  		dump("application.js: error in init(): " + e + "\n");
  	}
  },

  getModel: function() {
	  return this.model;
  },

  getUserManager: function() {
	  return this.userManager;
  },

  isUpdate: function() {
	if (smConfig.getBoolPref("uninstall")) {
		// it seems uninstall did not happen previously, now sxipper is reinstalled
		// disable uninstall flag for now..
		smConfig.setBoolPref("uninstall", false);
	}
	
	// Compare the lastest installed patch version available (smConstants.latestPatchLevel)
	// to the latest one installed (pref "patchVersion"). If they are different, or the
    // preference does not exist, set the oldInstallVersion and newInstallVersion accordingly.
    try {
     	var patchVersion = smConfig.getCharPref("patchVersion");
     /*
     	// if no version find previous versions from legacy prefs
     	if (!patchVersion) { // legacy 2.0 alpha release (2.0.0.23700)
	        var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	        var legacyBranch = prefs.getBranch(smConstants.legacy2Prefs_branch);
     		patchVersion = smConfig.getCharPref("version.number", legacyBranch);
     		smLog("isUpdate: updating 2.0 legacy version: " + patchVersion);
     	}
     */
     	if (!patchVersion) { // leagcy <2.0
	        var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	        var legacyBranch = prefs.getBranch(smConstants.legacyPrefs_branch);
     		patchVersion = smConfig.getCharPref("version.number", legacyBranch);
     		smLog("isUpdate: updating legacy version: " + patchVersion);
     	}

		// Compare the version number of install.rdf (what was cached
	    // by Mozilla)  with the one saved in the preferences
	    // (sxipper.version.number).  If they are different, or the
	    // preference does not exist, load and display a web page in a new
	    // tab.
	    var versionPrefID = "version.number";
	    var currentVersionNum  = smUtils.getInstalledVersion();
	    smUtils.debug('installedVersion:'+	currentVersionNum, L_INFO);
	    try {
	     	var installVersion = smConfig.getCharPref(versionPrefID);
	     	if (!installVersion && patchVersion) {
	     		installVersion = patchVersion; // for 2.0.x
	     	}
	     	if (installVersion != currentVersionNum) {
	     		this.oldInstallVersion = installVersion;
	     		this.newInstallVersion = currentVersionNum;
	            smConfig.setCharPref(versionPrefID, currentVersionNum);
	            //return true
	     	}
	    }
	    catch (e) {
	    	smLog("initApplication: "+e + "\n" + String(e.stack), L_ERROR);
	        smConfig.setCharPref(versionPrefID, currentVersionNum);
	    }
     	
		var comparator = smJslib.jslibGetService("@mozilla.org/xpcom/version-comparator;1", "nsIVersionComparator");
     	if (!patchVersion) { // new install
     		smConfig.setCharPref("patchVersion", smConstants.latestPatchLevel);
     		this.oldPatchVersion = null;
     		this.newPatchVersion = smConstants.latestPatchLevel;
     		return false;
     	} else if (comparator.compare(patchVersion, smConstants.latestPatchLevel) < 0) { // update if newer patches avail.
   			//disable sxipper while applying patches
			var isEnabled = smConfig.getBoolPref('sxipperEnabled');
			smConfig.setBoolPref('wasSxipperEnabledPriorUpdating', isEnabled);
			smConfig.setBoolPref('sxipperEnabled', false);
	     	
     		this.oldPatchVersion = patchVersion;
     		this.newPatchVersion = smConstants.latestPatchLevel;
            return true
     	}
    }
    catch (e) {
    	smLog("initApplication: "+e, L_ERROR);
    }
    return false;
  },
  

  initApplication: function() {
  	var currentStatus = this.isApplicationInitialized;
	this.isApplicationInitialized = smConstants.applicationInitializedDisabled;
	//smLog('initApplication');
	if (!currentStatus) {
		currentStatus = smConstants.applicationNotInitialized;
	}

	if (currentStatus == smConstants.applicationNotInitialized) {
		this.addObserver();
	}

	var sxipperEnabled = smConfig.getBoolPref("sxipperEnabled");
	this.isApplicationInitialized = sxipperEnabled ? smConstants.applicationInitializedEnabled : smConstants.applicationInitializedDisabled;
 
	return currentStatus;
  },
  
   
  	//TODO besides caching do only one request for same name at a time
  	// get mapper info: 
  	// -asynch. if there is a updateCallbackFunction
  	// TODO -synch. if there is no updateCallbackFunction -> returns [name, url, skilllevel]
	getMapperInfo: function(mapperId, updateCallbackFunction) {
		if (mapperId==null) {
			return null;
		}
		// mapInfo: 0->name, 1->url
		var mapInfo = this.mapInfoCache[mapperId];
		if (mapInfo) {
			// cache hit !
			if (updateCallbackFunction) {
		     	updateCallbackFunction(mapInfo[0], mapInfo[1], mapInfo[2]);
		     } else {
		     	return mapInfo;
		     }
		} else {
			// retrieve mapper info from server..
	        var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
		              .createInstance(Components.interfaces.nsIXMLHttpRequest);
	        var url = smConfig.getServiceUrl("corePlain") + '/user/info/' + encodeURIComponent(mapperId);
			if (updateCallbackFunction) {
				// asynch
		        req.open('GET', url, true);
		        req.setRequestHeader('User-Agent', smConfig.getUserAgentString());
				req.onreadystatechange = this.getMapperInfoCallback(req, mapperId, this.mapInfoCache, updateCallbackFunction);
		        req.send(null);
		    } else {
		    	// synch
		    	smLog("getMapperInfo:"+mapperId);
		    	try {
			        req.open('GET', url, false);
			        req.setRequestHeader('User-Agent', smConfig.getUserAgentString());
			        req.send(null);
			    	var execute = this.getMapperInfoCallback(req, mapperId, this.mapInfoCache);
			    	execute();
			    	return this.mapInfoCache[mapperId];
		    	} catch (e) {
					smUtils.debug("Couldn't update user name/credits: "+mapperId+","+e, L_ERROR);
		    		return null;
		    	}
		    }
        }
	},
	
	//internal use only
	getMapperInfoCallback: function (req, mapperId, mapInfoCache, updateCallbackFunction) {
		return function() {
	  		try {
			    if (!updateCallbackFunction || req.readyState == 4 
			      && req.status == 200 && req.responseText && req.responseXML) {
			        smLog(req.responseText);
			        var doc = req.responseXML.documentElement;
		            //TODO reflect server API
		            if (doc.tagName != "error") {
		            	var child = doc.firstChild;
		            	var name = child.getAttribute("name");
		            	var url = child.getAttribute("url");
		            	var skillLevel = child.getAttribute("skilllevel");
				        if (name && url) {
				           if (updateCallbackFunction) {
				           		updateCallbackFunction(name, url, skillLevel);
				           }
					       mapInfoCache[mapperId] = [name, url, skillLevel];
					    }
			        }
				}
		   } catch (e) {
		   	  smUtils.debug("Couldn't update user name/credits: "+mapperId+","+e, L_ERROR);
		   }
	   }
	},
	/*
	// store (in memory) last form which registration map isLoginPending
	recordRegistrationData: function(form, map) {
		if (map.isLoginPending) {
			var rootDomainName =  smUtils.getRootDomain(form.ownerDocument.location);
			smLog("recording registration Data for domain:"+rootDomainName);
			var fields = form.elements;
			this.registrationRecordFields = {};
			//TODO verify this
			for (var i=0; i<fields.length; i++) {
				if (fields[i].tagName.toLowerCase()=="input") {
					var name = fields[i].getAttribute('name');
					var type = fields[i].getAttribute('type');
					var value = fields[i].value;
					if (name!=null && value!=null && value!="") {
						this.registrationRecordFields[value] = [type, name];
						smLog("identifyUsernameField hashtable entry: "+value+","+type+","+name);
					}
				}
			}
			this.registrationRecordMap = map;
			this.registrationRecordDomain = rootDomainName;
		}
	},
	
	isRegistrationPending: function(form) {
		var isPending = false;
		if (this.registrationRecordDomain) {
			var rootDomainName =  smUtils.getRootDomain(form.ownerDocument.location);
			if (this.registrationRecordDomain == rootDomainName) {
				isPending = true;
			}
		}
		smLog("isRegistrationPending:"+isPending);
		return isPending;
	},
	
	// update registration map if we can identify username field using the recorded data
	// by comparing login form fields values with registration form fields values..
	updateRegistrationMap: function(loginForm) {
		smLog("lets see if we need to update registration map");
		if (this.isRegistrationPending(loginForm)) {
			var loginFields = smUtils.getEditableInputs(loginForm);
			// check for usernamefield
			var usernameField = this.identifyUsernameField(loginFields, this.registrationRecordFields);
			if (usernameField != null) {
				this.registrationRecordMap.usernameField = usernameField;
				//TODO
				var usernameHostname = smUtils.getHostnameUnified(loginForm.ownerDocument.location);
				if (usernameHostname && this.registrationRecordMap.actionHostname!=usernameHostname) {
					this.registrationRecordMap.usernameHostname=usernameHostname;
				}
				this.registrationRecordMap.isLoginPending=false;
				this.registrationRecordMap.isAutoGenerated=true;
				// lets not come back to this function again/soon
				this.registrationRecordDomain = null;
				// smMap.sendToServer(this.registrationRecordMap);
				//this.registrationRecordFields = null;
				//this.registrationRecordMap = null;
				return this.registrationRecordMap;
			}
		}
		return null;
	},

	// given the (filled) fields from a login and registration form	
	// identify the username field of the registration form
	identifyUsernameField: function(loginFields, hashtable) {
		// TODO create hashtable in recordRegistrationData (once)
		// put 2nd set of fields in a hashtable
			
		var usernameField = null;
		var passwordCounter = 0;
		for (var i=0; i<loginFields.length; i++) {
			//var fieldName = loginFields[i].getAttribute('name');
			var fieldType = loginFields[i].getAttribute('type');
			var fieldValue = loginFields[i].value;
			var registration = hashtable[fieldValue];
			smLog("identifyUsernameField login field: "+fieldValue+","+fieldType	);
			if (fieldValue!=null && registration!=null) {
				// field values matched
				smLog("identifyUsernameField field values matched: "+fieldValue);
				if (fieldType && fieldType.toLowerCase()=='password' 
				  && registration[0].toLowerCase()=='password') {
					// need a password match
					passwordCounter++;
				} else if (smUtils.isFieldTypeText(fieldType) 
				  && smUtils.isFieldTypeText(registration[0])) {
					// need exactly one username match
					if (!usernameField) {
						usernameField = registration[1];
					} else {
						//multiple matches -> don't do anything
						usernameField = null;
						break;
					}
				}
			}
		}
		if (passwordCounter && usernameField!=null) {
			smLog("identifyUsernameField: "+usernameField);
			return usernameField;
		}
		return null;
	},
	*/
	updateDontShowAgainMapList: function(map) {
		var branch = smConfig.getPrefsBranchIgnoreMap(map);
		var key = map.getFormHash();
		//smLog("dontShowAgain map key: "+key);
		if (key) {
			smConfig.setBoolPref(key, !map.isIgnored, branch);
		}
	},
	
	isDontShowAgainMap: function(map) {
		var branch = smConfig.getPrefsBranchIgnoreMap(map);
		var key = map.getFormHash();
		if (branch && key) {
			return smConfig.getBoolPref(key, branch);
		}
		return false;
	},
	
	setDomainNoCache: function(domain, isEnabled) {
		//smLog("setDomainNoCache: "+domain+", "+isEnabled);
		if (!domain) {
			return;			
		}
		//TODO remove entry if exists and isEnabled==false
		var lookup = this.noCacheDomainHashTable[domain];
		if (!isEnabled && lookup==null) {
			return;
		} else if (!isEnabled && lookup) {
			delete this.noCacheDomainHashTable[domain];
		} else if (isEnabled) {
			this.noCacheDomainHashTable[domain] = true;
		}
	},
	
	isDomainNoCache: function(domain) {
		var isEnabled = this.noCacheDomainHashTable[domain]==true;
		//smLog("isDomainNoCache: "+domain+", "+isEnabled);
		return isEnabled;
	},
	
	updateMapCache: function(map) {
		// smLog("updateMapCache map uid: "+map.uid);
		this.mapCache[map.uid]=map;
	},
	
	getMapFromCache: function(uid) {
		smLog("getMapFromCache map uid: "+uid);
		return this.mapCache[uid];
	},
	
	updateMapCachePerFormHash: function(map) {
		// smLog("updateMapCachePerFormHash map hash: "+map.getFormHash());
		var hash = map.getFormHash();
		var domain = map.domain;
		domain = domain?domain:"template";
		var domainCache = this.mapCachePerFormHash[domain];
		if (!domainCache) {
			domainCache = {};
			this.mapCachePerFormHash[domain] = domainCache;
		}
		domainCache[hash] = map;
	},

	getMapFromCachePerFormHash: function(domain, hash) {
		smLog("getMapFromCachePerFormHash map hash: "+hash);
		var domainCache = this.mapCachePerFormHash[domain];
		if (domainCache) {
			return domainCache[hash];
		}
		return null;
	},

	// will add urls of forms with method equal to GET
	addFormUrl: function(url) {
		smLog("addFormUrl: "+url);
		if (!url || this.formUrlHashtable[url]) {
			return;
		}
		this.formUrlHashtable[url] = true;
	},
	
	hasFormUrl: function(url) {
		//smLog("hasFormUrl: "+url);
		if (!url) {
			return false;
		}
		return !!this.formUrlHashtable[url];
	},

    // Support server-side discovery on non-sxipper OpenID URLs
    // send to core service /discoverOpenID
    // that will return a standard response xml document
    // response codes: 404 - OpenID server unreachable
    //                 400 - OpenID not configured (not an OpenID URL)
    //                 200 - OpenID OK
    //                 202 - OpenID OK & supports OP Delegation
    discoverOpenID: function(identifier, updateCallbackFunction) {
  		if (!smUserManager.prepareHttpAuth(null, true)) {
			smLog("discoverOpenID: auth creds not available.");
			return null;
		}
        var openidDiscoveryInfo = {code: 0, isError: false, message: ""};
        var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
            .createInstance(Components.interfaces.nsIXMLHttpRequest);
        //TODO change core to openid for 2.0
        var url = smConfig.getServiceUrl("openid") + "/openid/discoverOpenID";
        smLog("discoverOpenID: " + identifier);
        if (updateCallbackFunction) {
            // asynch
            req.open("POST", url, true);
            req.setRequestHeader("Content-Type", smConstants.MIME_TYPE_URL_ENCODED_FORM);
            req.onreadystatechange = this.discoverOpenIDCallback(req, identifier, openidDiscoveryInfo, updateCallbackFunction);
            req.send("openid_identifier=" + encodeURIComponent(identifier));
        } else {
            // synch
            req.open("POST", url, false);
            req.setRequestHeader("Content-Type", smConstants.MIME_TYPE_URL_ENCODED_FORM);
            req.send("openid_identifier=" + encodeURIComponent(identifier));
            var execute = this.discoverOpenIDCallback(req, identifier, openidDiscoveryInfo);
            execute();
            return openidDiscoveryInfo;
        }
    },

    discoverOpenIDCallback: function(req, identifier, discoveryInfo, updateCallbackFunction) {
        return function() {
            try {
                if ((!updateCallbackFunction || req.readyState == 4)
                        && req.status == 200 && req.responseText && req.responseXML) {
                    smLog("discoverOpenIDCallback: " + req.responseText);
					var doc = req.responseXML.documentElement;
                    // Standard response document:
                    // <response isError="" code=""></response>
                    if (doc.tagName == "response") {
                        var isError = doc.getAttribute("isError");
                        var code = doc.getAttribute("code");
                        var message = doc.firstChild.nodeValue;
                        message = message.replace(/^\s*|\s*$/g, "");

                        if (updateCallbackFunction) {
                            updateCallbackFunction(isError, code, message);
                        } else {
                            discoveryInfo.code = code;
                            if (isError == "true") {
                                discoveryInfo.isError = true;
                            }
                            discoveryInfo.message = message;
                        }
                    }
                }
            } catch (e) {
                smUtils.debug("Couldn't discover OpenID: " + identifier + "," + e,  L_ERROR);
            }
        };
    },

    //discoverOpenIDClientSide: function(identifier) { },

	addObserver: function() {
		var observer = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces["nsIObserverService"]);
		observer.addObserver(this.uninstallObserver, "em-action-requested", false);
		observer.addObserver(this.uninstallObserver, "quit-application-granted", false);
		
		this.preferencesObserver.add();
	},

	removeObserver: function() {
		var observer = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces["nsIObserverService"]);
		observer.removeObserver(this.uninstallObserver, "em-action-requested");
		observer.removeObserver(this.uninstallObserver, "quit-application-granted");

		this.preferencesObserver.remove();
	},
	
	QueryInterface: function(aIID)  {
	  if (!aIID.equals(CI.nsIObserver) &&
	      !aIID.equals(CI.nsISupports))
	    throw Components.results.NS_ERROR_NO_INTERFACE;
	  return this;
	}
	
};
SxipperService.prototype.uninstallObserver = {
	observe: function(subject, topic, data)  {
		try {
			if (topic=="em-action-requested") {
				item = subject.QueryInterface(Components.interfaces.nsIUpdateItem);
				if (item.id != smConstants.extensionId) {
					return;
				}
				if (data=="item-upgraded") {
				    smLog("Observed Upgrade Sxipper event", L_INFO);
					comparator = smJslib.jslibGetService("@mozilla.org/xpcom/version-comparator;1", "nsIVersionComparator");
					var currentVersionNum = smUtils.getInstalledVersion();
					//TODO get version of staged xpi.. (item.version gives current version)
//				    if (comparator.compare(stagedVersion, currentVersionNum)<0) {
//					    smLog("Observed Downgrade Sxipper event: " + stagedVersion+"<"+currentVersionNum, L_INFO);
//				    	//TODO remove new xpi with user consent
//				    }
					smConfig.logStep("addon","upgraded");
				} else if (data=="item-uninstalled") {
					smLog("Observed Uninstall Sxipper event", L_INFO);
					// "schedule" deleting data (files) and preferences
			   		smConfig.setBoolPref("uninstall", true);
					smUtils.loadUninstallFeedbackPage();
					smUserManager.unregister();
					smConfig.logStep("addon","uninstall");
				} else if (data=="item-cancel-action") {
					smLog("Observed item-cancel-action event", L_INFO);
					smConfig.removePref("uninstall");
					smUserManager.cancelUnregister();
					smConfig.logStep("addon","cancel-action");
				} else if (data=="item-disabled") {
					smLog("Observed item-disabled event", L_INFO);
					//Note: item will not be disabled until next restart
					// be careful what to delete / restore already
					smUtils.removeSxipperCookie();
					smUpdateManager.restoreFirefoxPreferences();
					smConfig.logStep("addon","disabled");
				} else if (data=="item-enabled") {
					smLog("Observed item-enabled event", L_INFO);
					smConfig.logStep("addon","enabled");
				}
			} else if (topic=="quit-application-granted") {
				if (smConfig && smConfig.getBoolPref("uninstall")) {
					dump("uninstalling sxipper\n");
					smUpdateManager.deleteSxipperData();
				} else {
					// flush datastore unwritten changes on quit
					// (if not an uninstall)
					smDataStore.personal.flushAll();
				}
			}
		} catch (e) {
			smLog("Error observing uninstall event: "+e, L_ERROR);
		}
	}
};

SxipperService.prototype.preferencesObserver = {
	signOnPrefs: null,
	sxipperPrefs: null,
	
	add: function() {
		this.signOnPrefs = Components.classes["@mozilla.org/preferences-service;1"]
							.getService(Components.interfaces.nsIPrefService)
							.getBranch("signon.");
 		this.signOnPrefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		this.signOnPrefs.addObserver("rememberSignons", this, false);

		this.sxipperPrefs = smConfig.getPrefsBranch();
 		this.sxipperPrefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		this.sxipperPrefs.addObserver("statusbar", this, false);
		this.sxipperPrefs.addObserver("sxipperEnabled", this, false);
		this.sxipperPrefs.addObserver("trainerName", this, false);
	},
	
	remove: function() {
		this.signOnPrefs.removeObserver("", this);
		this.sxipperPrefs.removeObserver("", this);
	},
	
	observe: function(subject, topic, data)  {
		try {
			if (topic != "nsPref:changed") {
				return;
			}
			
			switch(data) {
				case "rememberSignons":
					smConfig.rememberSignonsToggle();
					break;

				case "statusbar":
				case "sxipperEnabled":
				case "trainerName":
					var observer = Components.classes["@mozilla.org/observer-service;1"]
											.getService(Components.interfaces["nsIObserverService"]);
					observer.notifyObservers(null, "sm-chrome-ui-update-request", null);
					break;
			}

		} catch (e) {
			smLog("SxipperService.preferencesObserver: Error! "+e, L_ERROR);
		}
	}
};


/***********************************************************
USAGE

sxipperService = Components.classes["@sxip.com/sxipper/application;1"].
                          createInstance(Components.interfaces.nsISxipperService).wrappedJSObject;

***********************************************************/

var singleton;

var SxipperServiceFactory = {
  createInstance: function (aOuter, aIID) {
    if (aOuter != null) {
      throw Components.results.NS_ERROR_NO_AGGREGATION;
    }
    if (!singleton) {
		singleton = new SxipperService();
		singleton.init();
    }
    return singleton.QueryInterface(aIID);
  }
};

/***********************************************************
module definition (xpcom registration)
***********************************************************/
var SxipperServiceModule = {
  _firstTime: true,

  registerSelf: function(aCompMgr, aFileSpec, aLocation, aType)
  {
    aCompMgr = aCompMgr.
        QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME,
        CONTRACT_ID, aFileSpec, aLocation, aType);
  },

  unregisterSelf: function(aCompMgr, aLocation, aType)
  {
  	try {
	  	if (singleton) {
	  		//TODO smHttpObserver.stop();
	  		singleton.removeObserver();
		  	if (singleton.model) {
		  		singleton.model.flush();
		  	}
	  	}
  	} catch (e) {
  		dump("error unloading sm model");
  	}
    aCompMgr = aCompMgr.
        QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.unregisterFactoryLocation(CLASS_ID, aLocation);
  },

  getClassObject: function(aCompMgr, aCID, aIID)
  {
    if (!aIID.equals(Components.interfaces.nsIFactory))
      throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    if (aCID.equals(CLASS_ID))
      return SxipperServiceFactory;

    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  canUnload: function(aCompMgr) { return true; }
};


/***********************************************************
module initialization

When the application registers the component, this function
is called.
***********************************************************/
function NSGetModule(aCompMgr, aFileSpec) { return SxipperServiceModule; }

