/***********************************************************************************
*  Sxipper
*  Copyright (c) 2006-2008 Sxip Identity Corporation
*  http://www.sxip.com
*
*  Patents pending.
* 
***********************************************************************************/ 

/*
 * Sxipper - Personal Data Autocomplete XPCOM Component
 * 
 * Developing notes: change to this file requires removing xpti.dat and compreg.dat
 * from the dev profile directory. 
 */


/***********************************************************
constants
***********************************************************/
const CI = Components.interfaces;

// UUID uniquely identifying our component
const CLASS_ID = Components.ID("{e0fd95d2-256f-4d59-a1d7-778f1bfdb548}");

// description
const CLASS_NAME = "Sxipper - Personal Data Autocomplete XPCOM Component";

// textual unique identifier
const CONTRACT_ID = "@mozilla.org/autocomplete/search;1?name=sxipper-personaldata";

const nsIAutoCompleteSearch        = Components.interfaces.nsIAutoCompleteSearch;

var smJslib = {};
//TODO
function smInclude(url) {
	var scriptLoader =  Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
		getService(Components.interfaces.mozIJSSubScriptLoader);
	scriptLoader.loadSubScript(url);
}

/***********************************************************
 class definition

 insert application wide functions/variables below

***********************************************************/

//class constructor
function PersonalDataSearchHandler() {
	this.wrappedJSObject = this;
	this.model = null;
};

// class definition
PersonalDataSearchHandler.prototype = {

  // define the function we want to expose in our interface
  hello: function() {
      return "XPCOM Hello World!";
  },
  
  init: function() {
	Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Components.interfaces.mozIJSSubScriptLoader)
    .loadSubScript("chrome://sxipper/content/jslib/jslib.js", smJslib);

	//dump('loading personalDataAutocomplete.js: fileUtils.js\n\n');
	smJslib.include(smJslib.JS_LIB_PATH+"debug/debug.js");
	smJslib.include(smJslib.JS_LIB_PATH+"io/file.js");
	smJslib.include(smJslib.JS_LIB_PATH+"io/fileUtils.js");
	smJslib.include(smJslib.JS_LIB_PATH+"io/dirUtils.js");
//	smJslib.include(smJslib.JS_LIB_PATH+"rdf/rdfBase.js");
//	smJslib.include(smJslib.JS_LIB_PATH+"rdf/rdfResource.js");
//	smJslib.include(smJslib.JS_LIB_PATH+"rdf/rdfContainer.js");
//	smJslib.include(smJslib.JS_LIB_PATH+"rdf/rdf.js");
	smJslib.include(smJslib.JS_LIB_PATH+"rdf/rdfFile.js");
	smInclude("chrome://sxipper/content/constants.js");
	smInclude("chrome://sxipper/content/utils.js");
	smInclude("chrome://sxipper/content/promptService.js");
	smInclude("chrome://sxipper/content/config.js");
    smInclude("chrome://sxipper/content/message.js");
	smInclude("chrome://sxipper/content/schema.js");
	smInclude('chrome://sxipper/content/group-schema.js');
	smInclude("chrome://sxipper/content/model.js");
	smInclude("chrome://sxipper/content/ledger.js");
	smInclude("chrome://sxipper/content/releaseProperties.js");
	
	
	var sxipperService;
	try{
		sxipperService = Components.classes["@sxip.com/sxipper/application;1"].getService().wrappedJSObject;
		//smUtils.debug("controller.js: "+sxipperService.hello());
	    this.model = sxipperService.getModel();
	    this.userManager = sxipperService.getUserManager();
	    // used in releaseProperties
	    smUserManager = this.userManager;
	} catch (e) {
		smUtils.debug("Couldn't load Sxipper application XPCOM component", L_ERROR);
		//TODO
		//throw e;
	}

  },
  
  /* nsISupports */
  QueryInterface : function handler_QI(iid) {
    if (iid.equals(Components.interfaces.nsISupports))
      return this;

    if (nsIAutoCompleteSearch && iid.equals(nsIAutoCompleteSearch))
      return this;

    throw Components.results.NS_ERROR_NO_INTERFACE;
  },


	// Future: use JSON to pass complex objects in searchString
	// http://developer.mozilla.org/en/docs/How_to_implement_custom_autocomplete_search_component
  /* nsIAutoCompleteSearch */
  startSearch : function startSearch(searchString, searchParam, previousResult, listener) {
    var simpleresult;
    //if ("@mozilla.org/autocomplete/simple-result;1" in Components.classes) {
    //  var result = Components.classes["@mozilla.org/autocomplete/simple-result;1"].createInstance();
    //  simpleresult = result.QueryInterface(Components.interfaces.nsIAutoCompleteSimpleResult);
    //} else {
		simpleresult = new AutoCompleteSimpleResult();
    //}
    simpleresult.setSearchString(searchString);
    simpleresult.setDefaultIndex(0);
    var searchParams = searchParam.split(";");
    var propertyType = searchParams[0];
    var paramType;
    if (searchParams.length>1) {
    	paramType = searchParams[1];
    }
    var hostname;
    var isFilterVerifiedEmailEnabled = false;
    var isFilterDisposableEmailEnabled = false;
    var isFilterUnverifiedEmailEnabled = false;
    var additionalItems;
    //TODO define as constant
    if (paramType=='hostname' && searchParams.length>2) {
    	hostname = searchParams[2];
    }
    //TODO define as constant
    else if (paramType=='filterVerified') {
    	isFilterVerifiedEmailEnabled = true;
    }
    //TODO define as constant
    else if (paramType=='filterDisposable') {
    	isFilterDisposableEmailEnabled = true;
    }
    // clause not used anymore
    else if (paramType=='filterUnverified') {
    	isFilterUnverifiedEmailEnabled = true;
    }
    //TODO define as constant
    else if (paramType=='addItems' && searchParams.length>2) {
    	additionalItems = [];
		for(var i=2; i<searchParams.length; i++) {
			additionalItems.push(searchParams[i]);
		}
    }
  
    	
    if (propertyType) {
		if (propertyType && propertyType==smConstants.sxipperPassword) {
			additionalItems = smGetMemorablePasswordAutocompleteOptions();
		} else {
	        var globUri = smGroupSchema.getGlobUriFromIdO(propertyType);
	    	if (globUri) {
	    		// smLog("glob uri of propertyType: "+globUri);
	    		propertyType = globUri;
	    	}
	    	var idos = this.model.getIdOs(propertyType, null, true);
	        // for preference pane
			// TODO merge code with smInitPro() in preferences.js..
	        if (isFilterVerifiedEmailEnabled) {
//	            smUtils.filterIdOsPerValue(idos,smConstants.nymUnverifiedStringRegExp,true);
	            smUtils.filterIdOsPerValue(idos,smConstants.nymGeneratedRegExp,true);
	            var verifiedEmails = this.model.getIdOs(smConstants.sxipperEmailVerifiedLocal, null, true);
	            smUtils.filterAlreadyVerified(idos, verifiedEmails,true);
	        } else if (isFilterDisposableEmailEnabled) {
//	            smUtils.filterIdOsPerValue(idos,smConstants.nymUnverifiedStringRegExp,true);
	            smUtils.filterIdOsPerValue(idos,smConstants.nymVerifiedPrefixRegExp,true);
	            smUtils.filterIdOsPerValue(idos,smConstants.nymGeneratedRegExp,true);
	        } else if (isFilterUnverifiedEmailEnabled) {
    // clause not used anymore
//	            smUtils.filterIdOsPerValue(idos,smConstants.nymUnverifiedStringRegExp,true);
	        }
	        //TODO escape '.' and other special reg exp char.
	    	var validValueRegExp = new RegExp("\\b"+searchString+"\\b",'i');
	        smReleaseProperties.filterAggregateIdos(idos, globUri, hostname, validValueRegExp, isFilterVerifiedEmailEnabled || isFilterDisposableEmailEnabled);
	
	    	for(var i=0; i<idos.length; i++) {
	    		var value = idos[i].getValue();
	    		if (isFilterVerifiedEmailEnabled) {
	    			value = value.replace(smConstants.nymVerifiedPrefixRegExp, smConstants.nymPrefsVerifiedPrefix);
	    		}
	    		// add ido to result with potential comment 
				simpleresult.appendMatch(value, smConstants.nymVerifiedPrefixRegExp.test(value)?"disposable":"");
	    	}
		}
    	if (additionalItems) {
    		for(var i=0; i<additionalItems.length; i++) {
				simpleresult.appendMatch(additionalItems[i], "");
    		}
    	}
    }
    if (simpleresult.matchCount > 0) {
      simpleresult.setSearchResult(Components.interfaces.nsIAutoCompleteResult.RESULT_SUCCESS);
    } else {
      simpleresult.setSearchResult(Components.interfaces.nsIAutoCompleteResult.RESULT_NOMATCH);
    }
    listener.onSearchResult(this, simpleresult);  
  },

  stopSearch : function stopSearch() {
  }  
};

/***********************************************************
USAGE

PersonalDataSearchHandler = Components.classes["@mozilla.org/autocomplete/search;1?name=sxipper-personaldata"].
                          createInstance(Components.interfaces.nsIAutoCompleteSearch).wrappedJSObject;

***********************************************************/


var PersonalDataSearchHandlerFactory = {
  createInstance: function (aOuter, aIID)
  {
    if (aOuter != null)
      throw Components.results.NS_ERROR_NO_AGGREGATION;
    var s = new PersonalDataSearchHandler();
    s.init();
    return s.QueryInterface(aIID);
  }
};

/***********************************************************
module definition (xpcom registration)
***********************************************************/
var PersonalDataSearchHandlerModule = {
  _firstTime: true,

  registerSelf: function(aCompMgr, aFileSpec, aLocation, aType)
  {
    aCompMgr = aCompMgr.
        QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME,
        CONTRACT_ID, aFileSpec, aLocation, aType);
  },

  unregisterSelf: function(aCompMgr, aLocation, aType)
  {
    aCompMgr = aCompMgr.
        QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.unregisterFactoryLocation(CLASS_ID, aLocation);
  },

  getClassObject: function(aCompMgr, aCID, aIID)
  {
    if (!aIID.equals(Components.interfaces.nsIFactory))
      throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    if (aCID.equals(CLASS_ID))
      return PersonalDataSearchHandlerFactory;

    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  canUnload: function(aCompMgr) { return true; }
};

function AutoCompleteSimpleResult() {
  /* nsIAutoCompleteResult */
  this.searchString = "";
  this.searchResult = this.RESULT_NOMATCH;
  this.defaultIndex = -1;
  this.errorDescription = "";
  this.matchCount = 0;
  /* nsIAutoCompleteSimpleResult */
  this.values = [];
  this.comments = [];
}

AutoCompleteSimpleResult.prototype = {
  /* nsIAutoCompleteResult */
  RESULT_IGNORED: 1,
  RESULT_FAILURE: 2,
  RESULT_NOMATCH: 3,
  RESULT_SUCCESS: 4,

  getValueAt: function getValueAt(index) {
    return this.values[index];
  },

  getCommentAt: function getCommentAt(index) {
    return this.comments[index];
  },

  getImageAt: function getImageAt(index) {
  	return null;
  },

  getStyleAt: function getStyleAt(index) {
  	return "suggesthint";
  },

  removeValueAt: function removeValueAt(rowIndex, removeFromDb) {
    this.values.splice(rowIndex, 1);
  },

  /* nsIAutoCompleteSimpleResult */
  setSearchString: function setSearchString(aSearchString) {
    this.searchString = aSearchString;
  },

  setErrorDescription: function setErrorDescription(aErrorDescription) {
    this.errorDescription = aErrorDescription;
  },

  setDefaultIndex: function setDefaultIndex(aDefaultIndex) {
    this.defaultIndex = aDefaultIndex;
  },

  setSearchResult: function setSearchResult(aSearchResult) {
    this.searchResult = aSearchResult;
  },

  appendMatch: function appendMatch(aValue, aComment) {
    this.values.push(aValue);
    this.comments.push(aComment);
    this.matchCount++;
  }
}


/***********************************************************
module initialization

When the application registers the component, this function
is called.
***********************************************************/
function NSGetModule(aCompMgr, aFileSpec) { return PersonalDataSearchHandlerModule; }

